/*
 * QuteCom, a voice over Internet phone
 * Copyright (C) 2010 Mbdsys
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
;
#ifndef PHONECALLSTATEUNKNOWN_H
#define PHONECALLSTATEUNKNOWN_H

#include "PhoneCallState.h"

#include "PhoneCall.h"

/**
 *
 * @ingroup model
 * @author Tanguy Krotoff
 */
class PhoneCallStateUnknown : public PhoneCallState {
public:

	EnumPhoneCallState::PhoneCallState getCode() const {
		return EnumPhoneCallState::PhoneCallStateUnknown;
	}

	void execute(PhoneCall & phoneCall,bool doublecall = false);
};

/**
 *
 * @ingroup model
 * @author Preetish Kakkar
 */
class PhoneCallStateBusy : public PhoneCallState {
public:

	EnumPhoneCallState::PhoneCallState getCode() const {
		return EnumPhoneCallState::PhoneCallStateBusy;
	}

	void execute(PhoneCall & phoneCall,bool doublecall = false) {
	}
};

/**
 *
 * @ingroup model
 * @author Preetish Kakkar
 */
class PhoneCallStateRejected : public PhoneCallState {
public:

	EnumPhoneCallState::PhoneCallState getCode() const {
		return EnumPhoneCallState::PhoneCallStateRejected;
	}

	void execute(PhoneCall & phoneCall,bool doublecall = false) {
	}
};

/**
 *
 * @ingroup model
 * @author Preetish Kakkar
 */
class PhoneCallStateUserNotFound : public PhoneCallState {
public:

	EnumPhoneCallState::PhoneCallState getCode() const {
		return EnumPhoneCallState::PhoneCallStateUserNotFound;
	}

	void execute(PhoneCall & phoneCall,bool doublecall = false) {
	}
};

/**
 *
 * @ingroup model
 * @author Preetish Kakkar
 */
class PhoneCallStateUserNotAvailable : public PhoneCallState {
public:

	EnumPhoneCallState::PhoneCallState getCode() const {
		return EnumPhoneCallState::PhoneCallStateUserNotAvailable;
	}

	void execute(PhoneCall & phoneCall,bool doublecall = false) {
	}
};

#endif	//PHONECALLSTATEUNKNOWN_H
