/*
 * QuteCom, a voice over Internet phone
 * Copyright (C) 2010 Mbdsys
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef MYPRESENCESTATEINVISIBLE_H
#define MYPRESENCESTATEINVISIBLE_H

#include "MyPresenceState.h"

/**
 *
 * @ingroup model
 * @author Tanguy Krotoff
 * @author Philippe Bernery
 */
class MyPresenceStateInvisible : public MyPresenceState {
public:

	MyPresenceState * online();

	MyPresenceState * offline();

	MyPresenceState * doNotDisturb();

	MyPresenceState * away();

	MyPresenceState * invisible();

	std::string toString() const {
		return toString_static();
	}

	static MyPresenceState * getInstance() {
		static MyPresenceStateInvisible presenceState;

		return &presenceState;
	}

private:

	MyPresenceStateInvisible() {
	}

	static std::string toString_static() {
		return "Invisible";
	}

};

#endif //MYPRESENCESTATEINVISIBLE_H
