/*
 * QuteCom, a voice over Internet phone
 * Copyright (C) 2010 Mbdsys
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef OWQTJABBERSETTINGS_H
#define OWQTJABBERSETTINGS_H

#include "QtIMAccountPlugin.h"

#include <string>
#include <QtCore/QObject>
#include <QtGui/QPalette>
#include <QtGui/QComboBox>
class IMAccount;
class UserProfile;

class QWidget;
namespace Ui { class JabberSettings; }

/**
 * Jabber settings for the user.
 *
 * @author Tanguy Krotoff
 */
class QtJabberSettings : public QtIMAccountPlugin {
	Q_OBJECT
public:

	QtJabberSettings(UserProfile & userProfile, IMAccount & imAccount, QDialog * parent);

	~QtJabberSettings();

	QWidget * getWidget() const {
		return _IMSettingsWidget;
	}

	virtual bool isValid() const;

	virtual void setIMAccount();

private:

	void init();

	bool eventFilter(QObject *obj, QEvent *ev);
	
	void showToolTip();
	
	void hideToolTip();

	Ui::JabberSettings * _ui;

	QWidget * _IMSettingsWidget;
	
	QString _toolTip;
	
	QPalette _originalPalette;

	QPalette _greyPalette;
	
	bool _toolTipShown;
};

#endif	//OWQTJABBERSTTINGS_H
