/*
 * QuteCom, a voice over Internet phone
 * Copyright (C) 2010 Mbdsys
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef OWQTADDSIPACCOUNT_H
#define OWQTADDSIPACCOUNT_H

#include "ILogin.h"

class CUserProfileHandler;
class QtLoginDialog;
class QWidget;

namespace Ui { class AddSIPAccount; }

/**
 * Qt login window.
 *
 * @author Tanguy Krotoff
 * @author Mathieu Stute
 * @author Xavier Desjardins
 */
class QtAddSIPAccount : public ILogin {
	Q_OBJECT
public:

	QtAddSIPAccount(QtLoginDialog * qtLoginDialog, QWidget* parent, CUserProfileHandler & cUserProfileHandler);

	~QtAddSIPAccount();

	virtual void load(const SipAccount & sipAccount);

	virtual void load(std::string sipAccountName);

	virtual void initPage();

private Q_SLOTS:

	void loginClicked();

	void helpButtonClicked();

	void aMandatoryLineHasChanged();

	virtual void languageChanged();

	void showAdvancedSettings(bool state);

private:

	virtual void setInfoMessage();

	virtual void setErrorMessage(const QString & message);

	virtual void setLoginLabel(const QString & message);
	
	virtual void setModify();

	virtual bool profileNameExists(std::string profileName);

	Ui::AddSIPAccount * _ui;

	int _reducedHeight;
	
	bool _modify;
	//name of account that will be modified
	std::string _accountName;
	//visible name of account that will be modified
	std::string _visibleName;
};

#endif	//OWQTADDSIPACCOUNT_H
